TYPO3.Flow - Bug # 32707

Status: Accepted Priority: Must have

Author: Daniel Poetzinger Category: Cache

Created: 2011-12-19 Assigned To: Karsten Dambekalns
Updated: 2013-05-21 Due date:

PHP Version:

Has patch: No

Complexity: easy

Affected Flow version: Git 1.0

Subject: Bad Bad FileBackend

Description

http:/qit.typo3.org/FLOW3/Packages/TYPO3.FLOWS.git?a=blob;f=Classes/Cache/Backend/FileBackend.php;h=ab724{855e1d6a30
7056d0010c6ba00138a01e9;hb=8daf64af85dbcd3030cc3d259e262d70d50daf92

The FileBackend is not working under middle to high load and also not working relyable on shared filesystems

The main reason is the set function:

- All fileoperations need to be atomic - so why is ->remove() called and after this the file is written to some temp file and then
renamed.

=> |t should work by just removing the ->remove call, the rename method will replace the existing entry.

Also the while (rename($temporaryCacheEntryPathAndFilename, $cacheEntryPathAndFilename) && $i < 5) seems to be
unnecessary - why is this done?

Other improvements might be to get rid of the extra cache meta data for expire time - maybe using filemtime is faster at the end (it
avoids expensive file_get_contents two times)

Related issues:

related to TYPOS3.Flow - Bug # 27989: Wrong check in our atomic writes code Resolved 2011-07-08
precedes (1 day) Core - Bug # 32709: Make FileBackend more stable Closed 2011-12-21 2011-12-21
History

#1 - 2011-12-19 21:46 - Daniel Poetzinger

the fixme mentioned in typo3 core might be also relevant

/I @FIXME: At least the result of rename() should be handled here, report to FLOWS3 could be fixed as well

#2 - 2012-01-04 13:42 - Karsten Dambekalns
- Status changed from New to Accepted

- Assigned To set to Karsten Dambekalns

- Target version setto 1.1

#3 - 2012-05-25 09:39 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 RC1

#4 - 2012-06-19 11:35 - Karsten Dambekalns

- Target version changed from 1.1 RC1 to 2.0 beta 1
- Affected Flow version changed from Git master to Git 1.0
http://git.typo3.org/FLOW3/Packages/TYPO3.FLOW3.git?a=blob;f=Classes/Cache/Backend/FileBackend.php;h=ab724f855e1d6a3007056d0010c6ba00138a01e9;hb=8daf64af85dbcd3030cc3d259e262d70d50daf92
http://git.typo3.org/FLOW3/Packages/TYPO3.FLOW3.git?a=blob;f=Classes/Cache/Backend/FileBackend.php;h=ab724f855e1d6a3007056d0010c6ba00138a01e9;hb=8daf64af85dbcd3030cc3d259e262d70d50daf92

#5 - 2012-12-12 09:20 - Karsten Dambekalns
- Target version changed from 2.0 beta 1 to 2.0

#6 - 2013-05-21 13:33 - Robert Lemke

- Target version changed from 2.0 to 2.0.1
